Bug 244016 - x11-wm/plasma5-kwin: switch to Xwayland snapshot
Summary: x11-wm/plasma5-kwin: switch to Xwayland snapshot
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: freebsd-kde (Team)
URL:
Keywords: needs-qa
Depends on:
Blocks:
 
Reported: 2020-02-10 10:29 UTC by Jan Beich
Modified: 2021-03-16 20:44 UTC (History)
3 users (show)

See Also:
tcberner: maintainer-feedback+


Attachments
v1 (1.13 KB, patch)
2020-02-10 10:29 UTC, Jan Beich
no flags Details | Diff
v2 (1.29 KB, patch)
2020-12-18 19:06 UTC, Tobias C. Berner
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Jan Beich freebsd_committer 2020-02-10 10:29:20 UTC
Created attachment 211531 [details]
v1

May improve stability for X11 applications. Chase ports r525681.

Disclaimer: I've never used KDE on FreeBSD, let alone with Wayland.
Comment 1 Tobias C. Berner freebsd_committer 2020-02-11 18:40:24 UTC
Moin moin 

Thanks, we are in the process of trying to get plasma-wayland to work/test/use it -- so that may be integrated into that work.


mfg Tobias
Comment 2 Jan Beich freebsd_committer 2020-02-13 04:44:29 UTC
Can you test plasma-wayland with an NVIDIA GPU? Apply the patch in bug 244087, enable NVIDIA option in x11-servers/xwayland-devel then check if hardware acceleration works in X11 applications.
Comment 4 Jan Beich freebsd_committer 2020-12-16 12:20:06 UTC
Ping. Without this helping kde@ (e.g., bug 251836) is PITA for those who dogfood Wayland.
Comment 5 Tobias C. Berner freebsd_committer 2020-12-17 15:46:21 UTC
(In reply to Jan Beich from comment #4)

Are there any negative side effects when switching to the -devel port?

mfg Tobias
Comment 6 Jan Beich freebsd_committer 2020-12-17 17:18:11 UTC
None after years of dogfooding. Sway package switched when released version of Xwayland (1.19.1) was actually less stable than snapshot. Later I've applied a WIP patch written by a KDE developer and extended by others (see PATCHFILES) but it is nop for unaware consumers like cage/hikari/wayfire.

non-devel version currently lacks https://gitlab.freedesktop.org/xorg/xserver/-/merge_requests/515 which is critical for hardware acceleration.
Comment 7 Jan Beich freebsd_committer 2020-12-17 17:34:14 UTC
xwayland-devel is updated frequently (usually once a week), so poudriere will rebuild plasma5-kwin, plasma5-plasma-workspace, etc. which maybe a bit annoying. If you only rebuild plasma5-kwin then poudriere won't obsolete indirect consumers. I often use the trick with qt5-webengine to quickly test yuzu-qt5 (one of my ports).

poudriere supports -S flag to reduce rebuilds but it's partially broken atm. See also https://github.com/DankBSD/ports/commit/e0bf02a902b2
Comment 8 Tobias C. Berner freebsd_committer 2020-12-18 19:06:35 UTC
Created attachment 220700 [details]
v2

Moin moin 

I would suggest using an option, what do you think?


mfg Tobias
Comment 9 Jan Beich freebsd_committer 2020-12-18 21:11:59 UTC
Comment on attachment 220700 [details]
v2

(In reply to Tobias C. Berner from comment #8)
> +OPTIONS_DEFAULT=	NORMAL

Non-default options have no impact on binary packages e.g.,

  $ pkg install sway kde5
  [...]
  Checking integrity... done (1 conflicting)
    - xwayland-1.20.9_2,1 conflicts with xwayland-devel-1.20.0.800 on /usr/local/bin/Xwayland
  Cannot solve problem using SAT solver, trying another plan
  [...]

  $ pkg info -d plasma5-kwin
  pkg: No package(s) matching plasma5-kwin

  $ pkg install kde5
  [...]
  Installed packages to be REMOVED:
	  sway: 1.5.1
	  wlroots: 0.12.0
	  xwayland-devel: 1.20.0.800
  [...]

  $ pkg info plasma5-kwin
  plasma5-kwin-5.20.4
  [...]
  Options        :
	  DEVEL          : off
	  NORMAL         : on
  [...]

  $ pkg info -d wlroots
  pkg: No package(s) matching wlroots

  $ pkg install sway
  [...]
  Installed packages to be REMOVED:
	  dolphin: 20.12.0
	  kde-baseapps: 20.12.0
	  kde5: 5.20.4.20.12.0
	  plasma5-kde-cli-tools: 5.20.4
	  plasma5-kdeplasma-addons: 5.20.4
	  plasma5-khotkeys: 5.20.4
	  plasma5-kinfocenter: 5.20.4
	  plasma5-kmenuedit: 5.20.4
	  plasma5-kwin: 5.20.4
	  plasma5-plasma: 5.20.4
	  plasma5-plasma-desktop: 5.20.4
	  plasma5-plasma-workspace: 5.20.4
	  plasma5-powerdevil: 5.20.4
	  plasma5-systemsettings: 5.20.4
	  xwayland: 1.20.9_2,1
  [...]
Comment 10 Max Brazhnikov freebsd_committer 2020-12-18 21:46:11 UTC
Is there a reason to keep both xwayland and xwayland-devel in the ports at all?
Comment 11 Jan Beich freebsd_committer 2020-12-18 22:36:53 UTC
Probably no, see bug 251947. From wlroots package POV I need xwayland fresh enough to support new features e.g.,
https://gitlab.freedesktop.org/xorg/xserver/-/merge_requests/270
https://github.com/swaywm/wlroots/pull/2092
Comment 12 Tobias Kortkamp freebsd_committer 2021-03-15 22:09:48 UTC
Please do this because the status quo causes some silly and unnecessary
problems.  For example, I cannot install x11-wm/sway alongside
x11-fm/dolphin:

  - xwayland-devel-1.20.0.875 [FreeBSD] conflicts with xwayland-1.20.9_2,1 [installed] on /usr/local/bin/Xwayland
Checking integrity... done (0 conflicting)
The following 8 package(s) will be affected (of 0 checked):

Installed packages to be REMOVED:
        dolphin: 20.12.3
        plasma5-kde-cli-tools: 5.20.5
        plasma5-kwin: 5.20.5
        plasma5-plasma-workspace: 5.20.5_1
        xwayland: 1.20.9_2,1

New packages to be INSTALLED:
        sway: 1.5.1_1 [FreeBSD]
        wlroots: 0.12.0 [FreeBSD]
        xwayland-devel: 1.20.0.875 [FreeBSD]

Number of packages to be removed: 5
Number of packages to be installed: 3

For now I have resolved this by monkeying around with pkg set but
I really should not have to do this.
Comment 13 commit-hook freebsd_committer 2021-03-16 20:16:27 UTC
A commit references this bug:

Author: adridg
Date: Tue Mar 16 20:15:58 UTC 2021
New revision: 568609
URL: https://svnweb.freebsd.org/changeset/ports/568609

Log:
  Switch KDE Plasma kwin (the WM & Compositor) to xwayland-devel

  This makes Plasma co-installable with sway and river and other
  Wayland-based compositors and makes life much easier for the
  folks working on Wayland bits, since then all the "current"
  compositors depend on the same wayland, rather than conflicting
  over xwayland vs. xwayland-devel.

  PR:		244016
  Submitted by:	jbeich
  Reported by:	jbeich

Changes:
  head/x11-wm/plasma5-kwin/Makefile
Comment 14 Adriaan de Groot freebsd_committer 2021-03-16 20:44:27 UTC
For what it's worth, I spent a day last week wrestling with exactly this and locally patched the kwin port to build against xwayland-devel. I think it's a fine stopgap measure for getting all the "current" Wayland compositors and things building and installed at once, for comparison purposes. Once things settle down, we can step the non-experimental ports back from -devel and stick to release versions again.

I did write up my experiences at https://euroquis.nl/freebsd/2021/03/16/wayland.html , which come down to: well, kwin doesn't work with Wayland on FreeBSD anyway.